#ifndef _GEOMETRY_GENERATOR_H
#define _GEOMETRY_GENERATOR_H

#include<vector>
#include "Dx11DemoBase.h"

class GeometryGenerator
{
private:
	GeometryGenerator() {}
public:
	//ģʽ
	static GeometryGenerator* GetInstance()
	{
		static GeometryGenerator instance;
		return &instance;
	}

	//һͨõĶṹλáߡߡ
	struct Vertex
	{
		Vertex() {}
		Vertex(const XMFLOAT3 _pos, XMFLOAT3 _normal, XMFLOAT3 _tangent, XMFLOAT2 _tex) :
			pos(_pos), normal(_normal), tangent(_tangent), tex(_tex) {}

		XMFLOAT3	pos;
		XMFLOAT3	normal;
		XMFLOAT3	tangent;
		XMFLOAT2	tex;
	};

	//ṹ㼯+
	struct MeshData
	{
		std::vector<Vertex>	vertices;
		std::vector<UINT>	indices;
	};

	//һ壺ָ(X)(Y)(Z)
	void CreateBox(float width, float height, float depth, MeshData &mesh);

	//һӣָܿ(X)ܸ߶(Z); mnΪ߷ϵĸ
	void CreateGrid(float width, float height, UINT m, UINT n, MeshData &mesh);

	//һԲ(ϡ)ָ϶˰뾶(topRadius)¶˰뾶(bottomRadius)߶(height)
	//sllicestack
	void CreateCylinder(float topRadius, float bottomRadius, float height, int slice, int stack, MeshData &mesh);
	
	//ֳɵԲϿ
	void AddCylinderTopCap(float topRadius, float bottomRadius, float height, int slice, int stack, MeshData &mesh);
	
	//ֳɵԲ¿
	void AddCylinderBottomCap(float topRadius, float bottomRadius, float height, int slice, int stack, MeshData &mesh);
	
	//һ壺ָ뾶(radius)slicestack
	void CreateSphere(float radius, int slice, int stack, MeshData &mesh);
};

#endif//_GEOMETRY_GENERATOR_H
