#ifndef _TEXTURE_DEMO_H_
#define _TEXTURE_DEMO_H_

#include "Dx11DemoBase.h"
#include "d3dx11effect.h"
#include "GeometryGenerator.h"

#pragma comment(lib,"d3d11.lib")
#pragma comment(lib,"d3dcompiler.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"dxguid.lib")

class TextureDemo : public Dx11DemoBase
{
public:
	TextureDemo();
	~TextureDemo();

	bool LoadContent() override;
	void UnLoadContent() override;

	void Update(float dt) override;
	void Render() override;

	void OnMouseDown(WPARAM btnState, int x, int y) override;
	void OnMouseUp(WPARAM btnState, int x, int y) override;
	void OnMouseMove(WPARAM btnState, int x, int y) override;
private:
	ID3D11Buffer*							m_pVertexBuffer;
	ID3D11Buffer*							m_pIndexBuffer;
	ID3D11InputLayout*						m_pInputLayout;

	ID3DX11Effect*							m_pFx;
	ID3DX11EffectShaderResourceVariable*	m_pFxTex;
	ID3DX11EffectTechnique*					m_pTechnique;
	ID3DX11EffectMatrixVariable*			m_pFxWorldViewProj;

	ID3D11ShaderResourceView*				m_pTexSRV;
	GeometryGenerator::MeshData				m_box;

	XMFLOAT4X4								m_world;
	XMFLOAT4X4								m_view;
	XMFLOAT4X4								m_proj;

	float									m_theta;
	float									m_phi;
	float									m_radius;
	POINT									m_lastMousePos;
};

#endif//_TEXTURE_DEMO_H_
